## Revalent Scientific Papers

+ Berardino, P., G. Fornaro, R. Lanari, and E. Sansosti (2002), A new algorithm for surface deformation monitoring based on small baseline differential SAR interferograms, _Geoscience and Remote Sensing, IEEE Transactions on, 40_(11), 2375-2383, doi:10.1109/TGRS.2002.803792.

+ Chaussard, E., F. Amelung, and Y. Aoki (2013), Characterization of open and closed volcanic systems in Indonesia and Mexico using InSAR time series, _Journal of Geophysical Research: Solid Earth, 118_(8), 3957-3969, doi:10.1002/jgrb.50288.

+ Chaussard, E., R. Bürgmann, H. Fattahi, R. M. Nadeau, T. Taira, C. W. Johnson, and I. Johanson (2015), Potential for larger earthquakes in the East San Francisco Bay Area due to the direct connection between the Hayward and Calaveras Faults, _Geophysical Research Letters, 42_(8), 2734-2741, doi:10.1002/2015GL063575.

+ Chen, C. W., and H. A. Zebker (2001), Two-dimensional phase unwrapping with use of statistical models for cost functions in nonlinear optimization, _JOSA A, 18_(2), 338-351, doi:10.1364/JOSAA.18.000338.

+ Doin, M. P., C. Lasserre, G. Peltzer, O. Cavalié, and C. Doubre (2009), Corrections of stratified tropospheric delays in SAR interferometry: Validation with global atmospheric models, _Journal of Applied Geophysics, 69_(1), 35-50, doi:10.1016/j.jappgeo.2009.03.010.

+ Fattahi, H., and F. Amelung (2013), DEM Error Correction in InSAR Time Series, _Geoscience and Remote Sensing, IEEE Transactions on, 51_(7), 4249-4259, doi:10.1109/TGRS.2012.2227761.

+ Fattahi, H., and F. Amelung (2015), InSAR bias and uncertainty due to the systematic and stochastic tropospheric delay, _Journal of Geophysical Research: Solid Earth, 120_(12), 8758-8773, doi:10.1002/2015JB012419.

+ Fattahi, H., P. Agram, and M. Simons (2016), A Network-Based Enhanced Spectral Diversity Approach for TOPS Time-Series Analysis, _IEEE Transactions on Geoscience and Remote Sensing, 55_(2), 777-786, doi:10.1109/TGRS.2016.2614925.

+ Jolivet, R., R. Grandin, C. Lasserre, M. P. Doin, and G. Peltzer (2011), Systematic InSAR tropospheric phase delay corrections from global meteorological reanalysis data, _Geophysical Research Letters, 38_(17), L17311, doi:10.1029/2011GL048757.

+ Jolivet, R., P. S. Agram, N. Y. Lin, M. Simons, M. P. Doin, G. Peltzer, and Z. Li (2014), Improving InSAR geodesy using global atmospheric models, _Journal of Geophysical Research: Solid Earth, 119_(3), 2324-2341, doi:10.1002/2013JB010588.

+ Marinkovic, P., and Y. Larsen (2013), Consequences of long-term ASAR local oscillator frequency decay - An empirical study of 10 years of data, paper presented at _Proceedings of the Living Planet Symposium_ (abstract), European Space Agency, Edinburgh, U. K.

+ Morales Rivera, A. M., F. Amelung, and P. Mothes (2016), Volcano Deformation Survey over the Northern and Central Andes with ALOS InSAR Time Series, _Geochemistry, Geophysics, Geosystems_, 17, 2869-2883, doi:10.1002/2016GC006393.

+ Pepe, A., and R. Lanari (2006), On the extension of the minimum cost flow algorithm for phase unwrapping of multitemporal differential SAR interferograms, _Geoscience and Remote Sensing, IEEE Transactions on, 44_(9), 2374-2383, doi:10.1109/TGRS.2006.873207.

+ Perissin, D., and T. Wang (2012), Repeat-pass SAR interferometry with partially coherent targets, _Geoscience and Remote Sensing, IEEE Transactions on, 50_(1), 271-280, doi:10.1109/tgrs.2011.2160644.

+ Rosen, P. A., S. Hensley, G. Peltzer, and M. Simons (2004), Updated repeat orbit interferometry package released, _Eos Trans. AGU, 85_(5), 47-47, doi:10.1029/2004EO050004.

+ Rosen, P. A., E. Gurrola, G. F. Sacco, and H. Zebker (2012), The InSAR scientific computing environment, paper presented at _EUSAR 2012_, 23-26 April 2012.

+ Tough, R. J. A., D. Blacknell, and S. Quegan (1995), A Statistical Description of Polarimetric and Interferometric Synthetic Aperture Radar Data, _Proceedings: Mathematical and Physical Sciences, 449_(1937), 567-589, doi:10.1098/rspa.1995.0059.

+ Werner, C., U. Wegmüller, T. Strozzi, and A. Wiesmann (2000), Gamma SAR and interferometric processing software, paper presented at _Proceedings of the ERS-Envisat symposium_, Gothenburg, Sweden.

+ Yu, C., Z. Li, and N. T. Penna (2018), Interferometric synthetic aperture radar atmospheric correction using a GPS-based iterative tropospheric decomposition model, Remote Sensing of Environment, 204, 109-121, doi:10.1016/j.rse.2017.10.038.

+ Yu, C., Z. Li, N. T. Penna, and P. Crippa (2018), Generic Atmospheric Correction Model for Interferometric Synthetic Aperture Radar Observations, Journal of Geophysical Research: Solid Earth, 123(10), 9202-9222, doi:10.1029/2017JB015305.

+ Yunjun, Z., H. Fattahi, and F. Amelung (2019), Small baseline InSAR time series analysis: Unwrapping error correction and noise reduction, _Computers & Geosciences, 133_, 104331, doi:10.1016/j.cageo.2019.104331.

+ Zebker, H. A., P. A. Rosen, and S. Hensley (1997), Atmospheric effects in interferometric synthetic aperture radar surface deformation and topographic maps, _Journal of Geophysical Research: Solid Earth, 102_(B4), 7547-7563, doi:10.1029/96JB03804.
